## cctools 3.4.2

=== apps/Makefile ===
include ../Makefile.config
include ../Makefile.rules

all test install clean:
	@for p in replica_exchange_protomol; do cd $$p && $(MAKE) $@ && cd .. ; done

.PHONY: all test install clean

=== chirp/Makefile ===
include ../Makefile.config
include ../Makefile.rules

all test install clean:
	for p in src test; do cd $$p && $(MAKE) $@ && cd .. ; done

.PHONY: all test install clean

=== sand/Makefile ===
include ../Makefile.config
include ../Makefile.rules

all install test clean:
	for p in src test ; do cd $$p && $(MAKE) $@ && cd .. ; done

.PHONY: all install test clean

=== apps/replica_exchange_protomol/Makefile ===

include ../../Makefile.config
include ../../Makefile.rules

all:

test:

install:
	cp replica_exchange_protomol_barrier ${CCTOOLS_INSTALL_DIR}/bin
	cp replica_exchange_protomol_nobarrier ${CCTOOLS_INSTALL_DIR}/bin

clean:

=== chirp/src/Makefile ===
include ../../Makefile.config
include ../../Makefile.rules

LOCAL_LDFLAGS = -ldttools -lchirp ${CCTOOLS_INTERNAL_LDFLAGS}

LIBRARY_SOURCES = chirp_global.c chirp_multi.c chirp_recursive.c chirp_reli.c chirp_client.c chirp_matrix.c chirp_stream.c chirp_ticket.c
SERVER_SOURCES = chirp_stats.c chirp_thirdput.c chirp_alloc.c chirp_audit.c chirp_acl.c chirp_group.c chirp_filesystem.c chirp_fs_hdfs.c chirp_fs_local.c chirp_fs_chirp.c chirp_ticket.c

PROGRAMS=chirp chirp_get chirp_put chirp_server chirp_status chirp_benchmark chirp_stream_files chirp_fuse chirp_distribute
SCRIPTS=chirp_audit_cluster chirp_server_hdfs
LIBRARIES=libchirp.a libchirp_client.${CCTOOLS_DYNAMIC_SUFFIX}
HEADERS=chirp_global.h chirp_multi.h chirp_reli.h chirp_client.h chirp_stream.h chirp_protocol.h chirp_matrix.h chirp_types.h chirp_recursive.h

TARGETS = ${PROGRAMS} ${LIBRARIES}
LIBRARY_OBJECTS = ${LIBRARY_SOURCES:%.c=%.o}
SERVER_OBJECTS = ${SERVER_SOURCES:%.c=%.o}

all: ${TARGETS}

# This is the library intended to be used by clients of the system.

libchirp.a: ${LIBRARY_OBJECTS}
	${CCTOOLS_AR} rv $@ $^
	ranlib $@

# This object exists primarily to get a linkable object for use
# by ROOT and other systems that want to load Chirp dynamically.
# Note that we explicitly include auth_all.o and ${CCTOOLS_DYNAMIC_AUTH_LIBS}
# to force the inclusion of the various authentication infrastructures.

libchirp_client.${CCTOOLS_DYNAMIC_SUFFIX}: ${LIBRARY_OBJECTS} ../../dttools/src/auth_all.o
	${CCTOOLS_LD} ${CCTOOLS_DYNAMIC_FLAG} -o $@ $^ ../../dttools/src/libdttools.a ${CCTOOLS_DYNAMIC_AUTH_LIBS}

chirp: chirp_tool.o libchirp.a
	${CCTOOLS_LD} -o $@ $^ ${CCTOOLS_READLINE_LDFLAGS} ${LOCAL_LDFLAGS}

chirp_server: chirp_server.o ${SERVER_OBJECTS} libchirp.a
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

chirp_get: chirp_get.o libchirp.a
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

chirp_put: chirp_put.o libchirp.a
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

chirp_benchmark: chirp_benchmark.o libchirp.a
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

chirp_status: chirp_status.o libchirp.a
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

chirp_fuse: chirp_fuse.o libchirp.a
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

chirp_distribute: chirp_distribute.o libchirp.a
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

chirp_matrix_benchmark: chirp_matrix_benchmark.o libchirp.a
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

chirp_matrix_roc: chirp_matrix_roc.o libchirp.a
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

chirp_matrix_verify: chirp_matrix_verify.o libchirp.a
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

chirp_stream_files: chirp_stream_files.o libchirp.a
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

test:	all

clean:
	rm -f core *~ *.o *.os *.a *.${CCTOOLS_DYNAMIC_SUFFIX} ${TARGETS}

install: all
	install -d ${CCTOOLS_INSTALL_DIR}
	install -d ${CCTOOLS_INSTALL_DIR}/bin
	install -d ${CCTOOLS_INSTALL_DIR}/lib
	install -d ${CCTOOLS_INSTALL_DIR}/include
	install -d ${CCTOOLS_INSTALL_DIR}/include/cctools
	if [ -f ${CCTOOLS_INSTALL_DIR}/bin/chirp_server ]; then mv ${CCTOOLS_INSTALL_DIR}/bin/chirp_server ${CCTOOLS_INSTALL_DIR}/bin/chirp_server.old; fi
	for file in ${PROGRAMS} ${SCRIPTS} ; do install $$file ${CCTOOLS_INSTALL_DIR}/bin/$$file ; done
	for file in ${LIBRARIES} ; do install $$file ${CCTOOLS_INSTALL_DIR}/lib/$$file ; done
	for file in ${HEADERS} ; do install $$file ${CCTOOLS_INSTALL_DIR}/include/cctools/$$file ; done

=== dttools/src/Makefile ===

include ../../Makefile.config
include ../../Makefile.rules

SOURCES = auth.c auth_all.c auth_unix.c auth_globus.c auth_kerberos.c auth_hostname.c auth_address.c auth_ticket.c b64_encode.c batch_job.c batch_job_condor.c batch_job_hadoop.c batch_job_local.c batch_job_mpi_queue.c batch_job_cluster.c batch_job_work_queue.c bitmap.c buffer.c catalog_query.c change_process_title.c chunk.c console_login.c clean_dir.c copy_stream.c create_dir.c daemon.c datagram.c debug.c delete_dir.c disk_info.c domain_name.c domain_name_cache.c dpopen.c envtools.c fast_popen.c full_io.c file_cache.c get_canonical_path.c get_line.c getopt.c hdfs_library.c hash_cache.c hash_table.c hmac.c http_query.c itable.c link.c list.c load_average.c memory_info.c mergesort.c md5.c mpi_queue.c nvpair.c nvpair_database.c password_cache.c preadwrite.c process.c sha1.c sleeptools.c sort_dir.c stringtools.c string_array.c text_array.c text_list.c timestamp.c timer.c url_encode.c username.c work_queue.c xmalloc.c

EXTRA_HEADERS = int_sizes.h macros.h batch_job_internal.h

OBJECTS = ${SOURCES:%.c=%.o}
HEADERS = ${SOURCES:%.c=%.h} ${EXTRA_HEADERS}
LIBRARIES = libdttools.a
PROGRAMS = catalog_server work_queue_worker work_queue_pool work_queue_status watchdog

ifeq (${CCTOOLS_USE_MPI},true)
	PROGRAMS += mpi_queue_worker
endif

TEST_PROGRAMS = work_queue_example microbench hmac_test chunk_test multirun
PROGRAM_SOURCES = ${PROGRAMS:%=%.c} ${TEST_PROGRAMS:%=%.c}
SCRIPTS = condor_submit_workers sge_submit_workers
CYGWINLIB = cygwin1.dll sh.exe

all: ${LIBRARIES} $(PROGRAMS) $(TEST_PROGRAMS)

auth_test: auth_test.o libdttools.a
	${CCTOOLS_LD} $^ ${CCTOOLS_INTERNAL_LDFLAGS} -o $@

catalog_server: catalog_server.o libdttools.a
	${CCTOOLS_LD} $^ ${CCTOOLS_INTERNAL_LDFLAGS} -o $@

watchdog: watchdog.o libdttools.a
	${CCTOOLS_LD} $^ ${CCTOOLS_INTERNAL_LDFLAGS} -o $@

microbench: microbench.o libdttools.a
	${CCTOOLS_LD} $^ ${CCTOOLS_INTERNAL_LDFLAGS} -o $@

multirun: multirun.o libdttools.a
	${CCTOOLS_LD} $^ ${CCTOOLS_INTERNAL_LDFLAGS} -o $@

work_queue_worker: work_queue_worker.o libdttools.a
	${CCTOOLS_LD} $^ ${CCTOOLS_INTERNAL_LDFLAGS} -o $@

mpi_queue_worker: mpi_queue_worker.o libdttools.a
	${CCTOOLS_MPI_LD} $^ ${CCTOOLS_INTERNAL_LDFLAGS} -o $@

work_queue_example: work_queue_example.c libdttools.a
	${CCTOOLS_LD} $^ ${CCTOOLS_INTERNAL_LDFLAGS} -o $@

work_queue_status: work_queue_status.c libdttools.a
	${CCTOOLS_LD} $^ ${CCTOOLS_INTERNAL_LDFLAGS} -o $@

hmac_test: hmac_test.o libdttools.a
	${CCTOOLS_LD} $^ ${CCTOOLS_INTERNAL_LDFLAGS} -o $@

chunk_test: chunk_test.o libdttools.a
	${CCTOOLS_LD} $^ ${CCTOOLS_INTERNAL_LDFLAGS} -o $@

work_queue_pool: work_queue_pool.o libdttools.a
	${CCTOOLS_LD} $^ ${CCTOOLS_INTERNAL_LDFLAGS} -o $@

libdttools.a: ${OBJECTS}
	${CCTOOLS_AR} rv $@ $^
	ranlib $@

${SOURCES} ${PROGRAM_SOURCES} : int_sizes.h

int_sizes.h: make_int_sizes
	./$< > $@

make_int_sizes: make_int_sizes.o
	${CCTOOLS_LD} $^ -o $@ ${CCTOOLS_INTERNAL_LDFLAGS}

test: all

clean:
	rm -f core *~ *.o *.os *.so libdttools.a make_int_sizes int_sizes.h large_chunk.txt $(PROGRAMS)

install: all
	install -d ${CCTOOLS_INSTALL_DIR}
	install -d ${CCTOOLS_INSTALL_DIR}/bin
	install -d ${CCTOOLS_INSTALL_DIR}/lib
	install -d ${CCTOOLS_INSTALL_DIR}/include
	install -d ${CCTOOLS_INSTALL_DIR}/include/cctools
	for file in ${LIBRARIES} ; do install $$file ${CCTOOLS_INSTALL_DIR}/lib/$$file ; done
	for file in ${HEADERS} ; do if [ -f $$file ] ; then install $$file ${CCTOOLS_INSTALL_DIR}/include/cctools/$$file ; fi ; done
	for file in ${PROGRAMS} ; do install $$file ${CCTOOLS_INSTALL_DIR}/bin/$$file ; done
	for file in ${SCRIPTS} ; do install $$file ${CCTOOLS_INSTALL_DIR}/bin/$$file ; chmod 755 ${CCTOOLS_INSTALL_DIR}/bin/$$file; done
	for file in ${CYGWINLIB} ; do if [ -f /bin/$$file ] ; then install /bin/$$file ${CCTOOLS_INSTALL_DIR}/bin/$$file ; fi ; done

=== dttools/test/Makefile ===
CCTOOLS_HOME = ../..

include ${CCTOOLS_HOME}/Makefile.config
include ${CCTOOLS_HOME}/Makefile.rules

all:

test:
	@echo running dttools tests
	@${CCTOOLS_HOME}/dttools/src/test_runner.sh TR_*.sh

clean:

install:

=== makeflow/src/Makefile ===
CCTOOLS_HOME = ../../

include ${CCTOOLS_HOME}/Makefile.config
include ${CCTOOLS_HOME}/Makefile.rules

TARGETS = makeflow

LOCAL_LDFLAGS= -ldttools ${CCTOOLS_INTERNAL_LDFLAGS}

all: ${TARGETS}

makeflow: makeflow.o ${CCTOOLS_HOME}/dttools/src/libdttools.a
	${CCTOOLS_LD} makeflow.o ${LOCAL_LDFLAGS} -o $@

clean:
	rm -f core *~ *.o *.a ${TARGETS} 

test: all

install: all
	install -d ${CCTOOLS_INSTALL_DIR}/
	install -d ${CCTOOLS_INSTALL_DIR}/bin
	install makeflow ${CCTOOLS_INSTALL_DIR}/bin
	chmod 755 condor_submit_makeflow
	install condor_submit_makeflow ${CCTOOLS_INSTALL_DIR}/bin
	install makeflow_log_parser ${CCTOOLS_INSTALL_DIR}/bin
	install makeflow_monitor ${CCTOOLS_INSTALL_DIR}/bin
	install starch ${CCTOOLS_INSTALL_DIR}/bin

=== parrot/src/Makefile ===
include ../../Makefile.config
include ../../Makefile.rules

TARGETS = parrot_run libparrot_client.a libparrot_helper.so parrot_lsalloc parrot_mkalloc parrot_getacl parrot_setacl parrot_whoami parrot_locate parrot_md5 parrot_cp parrot_timeout
PARROT_OBJECTS =  pfs_main.o pfs_poll.o tracer.o pfs_dispatch.o pfs_dispatch64.o pfs_process.o pfs_channel_cache.o pfs_channel.o pfs_sys.o pfs_table.o pfs_resolve.o pfs_service.o pfs_file.o pfs_file_cache.o pfs_dir.o pfs_dircache.o pfs_pointer.o pfs_location.o ibox_acl.o pfs_service_local.o pfs_service_http.o pfs_service_grow.o pfs_service_chirp.o pfs_service_multi.o pfs_service_nest.o pfs_service_ftp.o pfs_service_gfal.o pfs_service_lfc.o pfs_service_rfio.o pfs_service_dcap.o pfs_service_irods.o irods_reli.o pfs_service_hdfs.o pfs_service_bxgrid.o pfs_service_s3.o pfs_service_xrootd.o pfs_service_cvmfs.o

LOCAL_LDFLAGS=-lchirp -ls3client -ldttools -lftp_lite -ldl ${CCTOOLS_INTERNAL_LDFLAGS}

all: ${TARGETS}

parrot_run: ${PARROT_OBJECTS}
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

libparrot_helper.so: parrot_helper.c
	gcc -shared -fPIC $< -o $@

parrot_lsalloc: parrot_lsalloc.o parrot_client.o
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

parrot_mkalloc: parrot_mkalloc.o parrot_client.o
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

parrot_getacl: parrot_getacl.o parrot_client.o
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

parrot_setacl: parrot_setacl.o parrot_client.o
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

parrot_whoami: parrot_whoami.o parrot_client.o
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

parrot_locate: parrot_locate.o parrot_client.o
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

parrot_timeout: parrot_timeout.o parrot_client.o
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

parrot_md5: parrot_md5.o parrot_client.o
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

parrot_cp: parrot_cp.o parrot_client.o
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

libparrot_client.a: parrot_client.o
	ar rv $@ $^

pfs_main.o pfs_dispatch.o pfs_dispatch64.o pfs_process.o tracer.o: tracer.table.h tracer.table.c tracer.table64.h tracer.table64.c

tracer.table64.c: tracer.table64.in tracer.table.process
	perl tracer.table.process table 64 <$< >$@

tracer.table64.h: tracer.table64.in tracer.table.process
	perl tracer.table.process header 64 <$< >$@

tracer.table.c: tracer.table.in tracer.table.process
	perl tracer.table.process table 32 <$< >$@

tracer.table.h: tracer.table.in tracer.table.process
	perl tracer.table.process header 32 <$< >$@

test:

clean:
	rm -f core *~ *.o *.a ${TARGETS} tracer.table.c tracer.table.h tracer.table64.c tracer.table64.h

install: all parrot_client.h
	install -d ${CCTOOLS_INSTALL_DIR}
	install -d ${CCTOOLS_INSTALL_DIR}/bin
	install -d ${CCTOOLS_INSTALL_DIR}/lib
	install -d ${CCTOOLS_INSTALL_DIR}/include
	install -d ${CCTOOLS_INSTALL_DIR}/include/cctools
	install parrot_run ${CCTOOLS_INSTALL_DIR}/bin
	install libparrot_client.a ${CCTOOLS_INSTALL_DIR}/lib
	install parrot_client.h ${CCTOOLS_INSTALL_DIR}/include/cctools
	install libparrot_helper.so ${CCTOOLS_INSTALL_DIR}/lib
	install parrot_identity_box ${CCTOOLS_INSTALL_DIR}/bin
	install make_growfs ${CCTOOLS_INSTALL_DIR}/bin
	install parrot_mkalloc ${CCTOOLS_INSTALL_DIR}/bin
	install parrot_lsalloc ${CCTOOLS_INSTALL_DIR}/bin
	install parrot_setacl ${CCTOOLS_INSTALL_DIR}/bin
	install parrot_getacl ${CCTOOLS_INSTALL_DIR}/bin
	install parrot_whoami ${CCTOOLS_INSTALL_DIR}/bin
	install parrot_md5 ${CCTOOLS_INSTALL_DIR}/bin
	install parrot_cp ${CCTOOLS_INSTALL_DIR}/bin
	install parrot_locate ${CCTOOLS_INSTALL_DIR}/bin
	install parrot_timeout ${CCTOOLS_INSTALL_DIR}/bin
	chmod 755 parrot_run_hdfs
	install parrot_run_hdfs ${CCTOOLS_INSTALL_DIR}/bin

=== sand/src/Makefile ===
include ../../Makefile.config
include ../../Makefile.rules

PROGRAMS = sand_align_master sand_align_kernel sand_filter_master sand_filter_kernel sand_compress_reads sand_uncompress_reads
SCRIPTS = sand_runCA_5.4 sand_runCA_6.1 sand_runCA_7.0
SOURCES =  compressed_sequence.o sequence_filter.c sequence.c matrix.c overlap.c align.c
OBJECTS = ${SOURCES:%.c=%.o}
HEADERS = *.h

all: ${PROGRAMS}

test: all

${PROGRAMS}: %: %.o libsandtools.a
	${CCTOOLS_LD} -o $@ $< -L. -lsandtools -ldttools ${CCTOOLS_INTERNAL_LDFLAGS}

libsandtools.a: $(OBJECTS)
	ar rv libsandtools.a $(OBJECTS)
	ranlib libsandtools.a

%.o: %.c
	${CCTOOLS_CC} ${CCTOOLS_INTERNAL_CCFLAGS} -c $< -o $@ -O4

clean:
	rm -f core *~ *.o *.os *.so $(PROGRAMS) libsandtools.a

install: all
	install -d ${CCTOOLS_INSTALL_DIR}
	install -d ${CCTOOLS_INSTALL_DIR}/bin
	for p in ${PROGRAMS} ${SCRIPTS}; do install $$p ${CCTOOLS_INSTALL_DIR}/bin; done

=== sand/test/Makefile ===
CCTOOLS_HOME = ../..

include ${CCTOOLS_HOME}/Makefile.config
include ${CCTOOLS_HOME}/Makefile.rules

all:

test:
	@echo running sand tests
	@${CCTOOLS_HOME}/dttools/src/test_runner.sh TR_*.sh

clean:

install:

=== work_queue/src/perl/Makefile ===
CCTOOLS_HOME = ../../..

include ${CCTOOLS_HOME}/Makefile.config

ccflags=${CCTOOLS_PERL_CCFLAGS} -I${CCTOOLS_HOME}/dttools/src
ldflags=${CCTOOLS_PERL_LDFLAGS} ${CCTOOLS_HOME}/dttools/src/libdttools.a

all: work_queue.pm work_queue.${CCTOOLS_DYNAMIC_SUFFIX}

work_queue_wrap.c work_queue.pm: ../work_queue.i
	@echo "SWIG work_queue.i (perl5)"
	@${CCTOOLS_SWIG} -perl5 -I${CCTOOLS_HOME}/dttools/src -o work_queue_wrap.c ../work_queue.i

work_queue_wrap.o: work_queue_wrap.c
	${CCTOOLS_CC} -fPIC -Wno-unused-value -Wno-unused-variable -c $< -o $@ ${ccflags}

work_queue.${CCTOOLS_DYNAMIC_SUFFIX}: work_queue_wrap.o
	${CCTOOLS_LD} ${CCTOOLS_DYNAMIC_FLAG} $< -o $@ ${ldflags}

test: all

clean:
	rm -fr work_queue.pm work_queue.${CCTOOLS_DYNAMIC_SUFFIX} work_queue_wrap.*

PERL_INSTALL_DIR=$(CCTOOLS_INSTALL_DIR)/lib/perl5/site_perl/$(CCTOOLS_PERL_VERSION)

install: all
	install -d $(PERL_INSTALL_DIR)
	install work_queue.$(CCTOOLS_DYNAMIC_SUFFIX) $(PERL_INSTALL_DIR)/work_queue.$(CCTOOLS_DYNAMIC_SUFFIX)
	install work_queue.pm $(PERL_INSTALL_DIR)/work_queue.pm

=== debian/changelog ===
cctools (3.4.2-2) unstable; urgency=low

  * Added patch to handle a missing CFLAGS variable in Python's sysconfig
    report (Closes: #661658).

 -- Michael Hanke <mih@debian.org>  Fri, 30 Mar 2012 12:40:01 +0200

cctools (3.4.2-1) unstable; urgency=low

  * New upstream release.
  * Drop external_python_version patch -- merged upstream.

 -- Michael Hanke <mih@debian.org>  Tue, 21 Feb 2012 16:45:28 +0100

=== debian/control ===
Source: cctools
Section: utils
Priority: extra
Maintainer: NeuroDebian Team <team@neuro.debian.net>
Uploaders: Michael Hanke <mih@debian.org>, Yaroslav Halchenko <debian@onerussian.com>
Build-Depends: debhelper (>= 7.0.50~), python-all-dev (>= 2.6.6-3~),
  libglobus-common-dev, libmysqlclient-dev, libfuse-dev, libkrb5-dev,
  libglobus-gss-assist-dev, net-tools, doxygen,
  libreadline6-dev | libreadline-dev, libncurses5-dev | libncurses-dev, swig,
  m4, mpi-default-dev
Standards-Version: 3.9.2
Homepage: http://nd.edu/~ccl/software/
Vcs-Browser: http://git.debian.org/?p=pkg-exppsy/cctools.git
Vcs-Git: git://git.debian.org/git/pkg-exppsy/cctools.git
XS-DM-Upload-Allowed: yes


Package: coop-computing-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, python
Suggests: coop-computing-tools-doc, condor, gridengine-client
Description: cooperative computing tools
 This is a collection of software that help users to share resources in a
 complex, heterogeneous, and unreliable computing environment. This includes:
 .
  * Chirp: A personal filesystem and I/O protocol that allows unprivileged users
    to share space securely, efficiently, and conveniently. When combined
    with Parrot, Chirp allows users to create custom wide-area
    distributed filesystems.
  * Parrot: A transparent user-level virtual filesystem that allows any ordinary
    program to be attached to a remote storage device such as an FTP
    server or a Chirp server.
  * Makeflow: A workflow system for parallel and distributed computing that uses
    a language very similar to Make.
  * Work Queue: A system and API for building master-worker style programs that
    scale up to thousands of processors.
  * All Pairs: A computational abstraction for running very large Cartesian
    products.
  * Wavefront: A computational asbtraction for running very large dynamic
    programming problems.
  * The Fault Tolerant Shell: A high-level programming language that allows
    users to combine the ease of shell scripting, the power of distributed
    programming, and the precision of compiled languages. Basically,
    parallel programming and exception handling for scripts.

Package: coop-computing-tools-dev
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: libraries and header files for coop-computing-tools
 These tools are a collection of software that help users to share resources in
 a complex, heterogeneous, and unreliable computing environment.
 .
 This package provides static libraries and header files for development.

Package: coop-computing-tools-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, libjs-jquery
Description: documentation for coop-computing-tools
 These tools are a collection of software that help users to share resources in
 a complex, heterogeneous, and unreliable computing environment.
 .
 This package provides the documentation (manual and API reference) in HTML
 format.

Package: python-workqueue
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
Description: cooperative computing tools work queue Python bindings
 CCTools's Work Queue is a system and API for building master-worker style
 programs that scale up to thousands of processors. This package provides
 bindings to access this system from Python.

=== debian/rules ===
#!/usr/bin/make -f

non_default_python_versions = $(shell python -c "print \"`pyversions -v -s`\".replace(\"`pyversions -v -d`\", '').strip()")

# one ring to rule them all ...
%:
	dh $@ --buildsystem=makefile --with python2

override_dh_auto_configure:
	# disable warning about unused results (necessary because warning is error
	# is ON)
	CFLAGS="$(CFLAGS) -Wno-unused-result" ./configure --with-globus-path /usr \
		--with-mysql-path /usr --with-krb5-path /usr --with-readline-path /usr \
		--with-mpi-path /usr --with-fuse-path /usr --with-zlib-path /usr \
		--with-python-path /usr

override_dh_auto_install:
	dh_auto_install -- CCTOOLS_INSTALL_DIR=$(CURDIR)/debian/tmp
	# make extensions for other supported python versions
	if [ -n "$(non_default_python_versions)" ]; then \
		for pyver in $(non_default_python_versions); do \
			PYTHON=/usr/bin/python$${pyver} ./configure.rerun ; \
			make -B -C work_queue/src/python install CCTOOLS_INSTALL_DIR=$(CURDIR)/debian/tmp ; \
		done ; \
	fi
	# fix permissions
	find debian/tmp/lib -name '*.py' -exec chmod 644 {} \;
	# remove undesired pieces
	-rm debian/tmp/doc/COPYING
	# upstream says it should not go into the page
	-rm debian/tmp/bin/watchdog
	# HDFS helpers are useless without HDFS in Debian
	-rm debian/tmp/bin/*_hdfs
	# newer doxygen puts jquery copy
	-rm debian/tmp/doc/api/html/jquery.js

override_dh_auto_clean:
	[ -e Makefile.config ] && dh_auto_clean || true
	-rm Makefile.config configure.rerun
	-rm -rf api hdfs-setup.template python/python-workqueue/setup.cfg
	# remove testrun left-overs
	-rm dttools/src/microbench dttools/src/work_queue_example
	-find $(CURDIR) -name '*.test.log' -delete
	-find $(CURDIR) -name '*_test' -delete
	-rm -rf sand/test/filter_verification/random.cand.filter.tmp/
	-rm -rf sand/test/test_20.cand.filter.tmp/
	-rm -f sand/test/test_20.cand sand/test/test_20.cfa sand/test/*.log
	-rm -rf makeflow/test/input/ makeflow/test/worker.pid
	-rm -rf makeflow/test/dirs/testcase.subdir.01.makeflow.makeflowlog
	-rm -rf makeflow/test/dirs/testcase.subdir.01.makeflow.wqlog
	-rm -rf makeflow/test/src/
	-rm dttools/src/multirun sand/test/banded.log

=== debian/watch ===
version=3
opts="uversionmangle=s/_/./" \
http://www.cse.nd.edu/~ccl/software/files/ \
   cctools-(\d)[\._]+(\d+)[\._]+(\d+)-src\.tar\.gz

## cctools 3.5.0

=== debian/changelog ===
cctools (3.5.0-1) unstable; urgency=low

  * New upstream release.
  * Remove obsolete patches 'missing_cflags' and 'python_compat'. They have
    been merged upstream.
  * Remove DM-upload flag, not needed anymore.
  * Bumped Standards-version to 3.9.3, no changes necessary.
  * Do not install the new 'apps' binaries. They carry language-specific
    filename extensions, and upstream was asked if renaming is possible. Until
    this is decided they won't be installed to avoid changing the API twice.

 -- Michael Hanke <mih@debian.org>  Fri, 15 Jun 2012 08:30:02 +0200

=== debian/rules ===
--- 
+++ 
@@ -23,6 +23,9 @@
 			make -B -C work_queue/src/python install CCTOOLS_INSTALL_DIR=$(CURDIR)/debian/tmp ; \
 		done ; \
 	fi
+	# for now remove the 'apps' scripts till upstream confirms that the language
+	# extension can be removed
+	rm -f debian/tmp/bin/*.py
 	# fix permissions
 	find debian/tmp/lib -name '*.py' -exec chmod 644 {} \;
 	# remove undesired pieces

## cctools 3.5.1

=== doc/Makefile ===
include ../Makefile.config

SOURCES=${shell ls man/*.m4}

HTMLFILES = ${SOURCES:%.m4=%.html}
TXTFILES = ${SOURCES:%.m4=%.txt}
PDFFILES = ${SOURCES:%.m4=%.pdf}
MANFILES = ${SOURCES:%.m4=%.1}
ZIPFILES = ${SOURCES:%.m4=%.1.gz}

all: ${CCTOOLS_DOCTARGETS}

htmlpages: ${HTMLFILES}

manpages: ${ZIPFILES}

apipages: api/html/index.html

api/html/index.html:
	doxygen cctools.doxygen.config

%.html: %.m4
	m4 -DHTML ${CCTOOLS_M4_ARGS} $< > $@

%.1: %.m4
	m4 -DMAN ${CCTOOLS_M4_ARGS} $< > $@

%.txt: %.1
	nroff -man $< > $@

%.gz: %
	gzip < $< > $@

install: all
	${CCTOOLS_INSTALL} -d $(CCTOOLS_INSTALL_DIR)/doc
	${CCTOOLS_INSTALL} -d $(CCTOOLS_INSTALL_DIR)/doc/man
	${CCTOOLS_INSTALL} -d $(CCTOOLS_INSTALL_DIR)/doc/images
	${CCTOOLS_INSTALL} -d $(CCTOOLS_INSTALL_DIR)/share/man/man1
	cp *.html $(CCTOOLS_INSTALL_DIR)/doc
	if [ -f man/chirp.html ]; then cp man/*.html $(CCTOOLS_INSTALL_DIR)/doc/man; fi
	if [ -f man/chirp.1.gz ]; then cp man/*.1.gz $(CCTOOLS_INSTALL_DIR)/share/man/man1; fi
	if [ -d api ]; then cp -rp api $(CCTOOLS_INSTALL_DIR)/doc; fi
	if [ -d images ]; then cp images/*.gif $(CCTOOLS_INSTALL_DIR)/doc/images; fi

test:

clean:
	rm -rf api $(HTMLFILES) $(MANFILES) $(ZIPFILES) *~

=== allpairs/src.tpds/Makefile ===
CCTOOLS_HOME = ../../../

include ${CCTOOLS_HOME}/Makefile.config
include ${CCTOOLS_HOME}/Makefile.rules

TARGETS = allpairs allpairs_status allpairs_wait allpairs_cleanup

LOCAL_LDFLAGS=-lchirp -ldttools ${CCTOOLS_INTERNAL_LDFLAGS}

all: ${TARGETS}

allpairs: allpairs.o
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS} -lm #-lefence

allpairs_status: allpairs_status.o ${CCTOOLS_HOME}/chirp/src/libchirp.a
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

allpairs_wait: allpairs_wait.o ${CCTOOLS_HOME}/chirp/src/libchirp.a
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

allpairs_cleanup: allpairs_cleanup.o ${CCTOOLS_HOME}/chirp/src/libchirp.a
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

test:

clean:
	rm -f core *~ *.o *.a ${TARGETS} 

install: all
	${CCTOOLS_INSTALL} -d ${CCTOOLS_INSTALL_DIR}/
	${CCTOOLS_INSTALL} -d ${CCTOOLS_INSTALL_DIR}/bin
	${CCTOOLS_INSTALL} allpairs ${CCTOOLS_INSTALL_DIR}/bin
	${CCTOOLS_INSTALL} allpairs_wait ${CCTOOLS_INSTALL_DIR}/bin
	${CCTOOLS_INSTALL} allpairs_status ${CCTOOLS_INSTALL_DIR}/bin
	${CCTOOLS_INSTALL} allpairs_cleanup ${CCTOOLS_INSTALL_DIR}/bin	
	${CCTOOLS_INSTALL} allpairs_wrapper.sh ${CCTOOLS_INSTALL_DIR}/bin

=== allpairs/src/Makefile ===
CCTOOLS_HOME = ../../

include ${CCTOOLS_HOME}/Makefile.config
include ${CCTOOLS_HOME}/Makefile.rules

TARGETS = allpairs_multicore allpairs_master

LOCAL_LDFLAGS=../../sand/src/libsandtools.a -ldttools ${CCTOOLS_INTERNAL_LDFLAGS}

all: ${TARGETS}

allpairs_multicore: allpairs_multicore.o allpairs_compare.o
	${CCTOOLS_LD} -o $@ $^ -lpthread ${LOCAL_LDFLAGS}

allpairs_master: allpairs_master.o allpairs_compare.o
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

test:

clean:
	rm -f core *~ *.o *.a ${TARGETS} 

install: all
	${CCTOOLS_INSTALL} -d ${CCTOOLS_INSTALL_DIR}/
	${CCTOOLS_INSTALL} -d ${CCTOOLS_INSTALL_DIR}/bin
	${CCTOOLS_INSTALL} allpairs_multicore ${CCTOOLS_INSTALL_DIR}/bin
	${CCTOOLS_INSTALL} allpairs_master ${CCTOOLS_INSTALL_DIR}/bin

=== chirp/src/Makefile ===
--- 
+++ 
@@ -73,13 +73,13 @@
 	rm -f core *~ *.o *.os *.a *.${CCTOOLS_DYNAMIC_SUFFIX} ${TARGETS}
 
 install: all
-	install -d ${CCTOOLS_INSTALL_DIR}
-	install -d ${CCTOOLS_INSTALL_DIR}/bin
-	install -d ${CCTOOLS_INSTALL_DIR}/lib
-	install -d ${CCTOOLS_INSTALL_DIR}/include
-	install -d ${CCTOOLS_INSTALL_DIR}/include/cctools
+	${CCTOOLS_INSTALL} -d ${CCTOOLS_INSTALL_DIR}
+	${CCTOOLS_INSTALL} -d ${CCTOOLS_INSTALL_DIR}/bin
+	${CCTOOLS_INSTALL} -d ${CCTOOLS_INSTALL_DIR}/lib
+	${CCTOOLS_INSTALL} -d ${CCTOOLS_INSTALL_DIR}/include
+	${CCTOOLS_INSTALL} -d ${CCTOOLS_INSTALL_DIR}/include/cctools
 	if [ -f ${CCTOOLS_INSTALL_DIR}/bin/chirp_server ]; then mv ${CCTOOLS_INSTALL_DIR}/bin/chirp_server ${CCTOOLS_INSTALL_DIR}/bin/chirp_server.old; fi
-	for file in ${PROGRAMS} ${SCRIPTS} ; do install $$file ${CCTOOLS_INSTALL_DIR}/bin/$$file ; done
-	for file in ${LIBRARIES} ; do install $$file ${CCTOOLS_INSTALL_DIR}/lib/$$file ; done
-	for file in ${HEADERS} ; do install $$file ${CCTOOLS_INSTALL_DIR}/include/cctools/$$file ; done
+	for file in ${PROGRAMS} ${SCRIPTS} ; do ${CCTOOLS_INSTALL} $$file ${CCTOOLS_INSTALL_DIR}/bin ; done
+	for file in ${LIBRARIES} ; do ${CCTOOLS_INSTALL} $$file ${CCTOOLS_INSTALL_DIR}/lib ; done
+	for file in ${HEADERS} ; do ${CCTOOLS_INSTALL} $$file ${CCTOOLS_INSTALL_DIR}/include/cctools ; done

=== dttools/src/Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 include ../../Makefile.config
 include ../../Makefile.rules
 
-SOURCES = auth.c auth_all.c auth_unix.c auth_globus.c auth_kerberos.c auth_hostname.c auth_address.c auth_ticket.c b64_encode.c batch_job.c batch_job_condor.c batch_job_hadoop.c batch_job_local.c batch_job_mpi_queue.c batch_job_cluster.c batch_job_work_queue.c bitmap.c buffer.c catalog_query.c change_process_title.c chunk.c console_login.c clean_dir.c copy_stream.c create_dir.c daemon.c datagram.c debug.c delete_dir.c disk_info.c domain_name.c domain_name_cache.c dpopen.c envtools.c fast_popen.c full_io.c file_cache.c get_canonical_path.c get_line.c getopt.c hdfs_library.c hash_cache.c hash_table.c hmac.c http_query.c itable.c link.c list.c load_average.c memory_info.c mergesort.c md5.c mpi_queue.c nvpair.c nvpair_database.c password_cache.c preadwrite.c process.c sha1.c sleeptools.c sort_dir.c stringtools.c string_array.c text_array.c text_list.c timestamp.c timer.c url_encode.c username.c work_queue.c xmalloc.c
+SOURCES = auth.c auth_all.c auth_unix.c auth_globus.c auth_kerberos.c auth_hostname.c auth_address.c auth_ticket.c b64_encode.c batch_job.c batch_job_condor.c batch_job_hadoop.c batch_job_local.c batch_job_mpi_queue.c batch_job_cluster.c batch_job_work_queue.c bitmap.c buffer.c catalog_query.c change_process_title.c chunk.c console_login.c clean_dir.c copy_stream.c create_dir.c daemon.c datagram.c debug.c delete_dir.c disk_info.c domain_name.c domain_name_cache.c dpopen.c envtools.c fast_popen.c full_io.c file_cache.c get_canonical_path.c get_line.c getopt.c hdfs_library.c hash_cache.c hash_table.c hmac.c http_query.c itable.c link.c list.c load_average.c memory_info.c mergesort.c md5.c mpi_queue.c nvpair.c nvpair_database.c password_cache.c preadwrite.c process.c sha1.c sleeptools.c sort_dir.c stringtools.c string_array.c text_array.c text_list.c timestamp.c timer.c url_encode.c username.c work_queue.c work_queue_catalog.c xxmalloc.c
 
 EXTRA_HEADERS = int_sizes.h macros.h batch_job_internal.h
 
@@ -76,14 +76,15 @@
 	rm -f core *~ *.o *.os *.so libdttools.a make_int_sizes int_sizes.h large_chunk.txt $(PROGRAMS)
 
 install: all
-	install -d ${CCTOOLS_INSTALL_DIR}
-	install -d ${CCTOOLS_INSTALL_DIR}/bin
-	install -d ${CCTOOLS_INSTALL_DIR}/lib
-	install -d ${CCTOOLS_INSTALL_DIR}/include
-	install -d ${CCTOOLS_INSTALL_DIR}/include/cctools
-	for file in ${LIBRARIES} ; do install $$file ${CCTOOLS_INSTALL_DIR}/lib/$$file ; done
-	for file in ${HEADERS} ; do if [ -f $$file ] ; then install $$file ${CCTOOLS_INSTALL_DIR}/include/cctools/$$file ; fi ; done
-	for file in ${PROGRAMS} ; do install $$file ${CCTOOLS_INSTALL_DIR}/bin/$$file ; done
-	for file in ${SCRIPTS} ; do install $$file ${CCTOOLS_INSTALL_DIR}/bin/$$file ; chmod 755 ${CCTOOLS_INSTALL_DIR}/bin/$$file; done
-	for file in ${CYGWINLIB} ; do if [ -f /bin/$$file ] ; then install /bin/$$file ${CCTOOLS_INSTALL_DIR}/bin/$$file ; fi ; done
-
+	${CCTOOLS_INSTALL} -d ${CCTOOLS_INSTALL_DIR}
+	${CCTOOLS_INSTALL} -d ${CCTOOLS_INSTALL_DIR}/bin
+	${CCTOOLS_INSTALL} -d ${CCTOOLS_INSTALL_DIR}/lib
+	${CCTOOLS_INSTALL} -d ${CCTOOLS_INSTALL_DIR}/doc
+	${CCTOOLS_INSTALL} -d ${CCTOOLS_INSTALL_DIR}/include
+	${CCTOOLS_INSTALL} -d ${CCTOOLS_INSTALL_DIR}/include/cctools
+	for file in ${LIBRARIES} ; do ${CCTOOLS_INSTALL} $$file ${CCTOOLS_INSTALL_DIR}/lib ; done
+	for file in ${HEADERS} ; do if [ -f $$file ] ; then ${CCTOOLS_INSTALL}  $$file ${CCTOOLS_INSTALL_DIR}/include/cctools ; fi ; done
+	for file in ${PROGRAMS} ; do ${CCTOOLS_INSTALL} $$file ${CCTOOLS_INSTALL_DIR}/bin ; done
+	for file in ${SCRIPTS} ; do ${CCTOOLS_INSTALL} $$file ${CCTOOLS_INSTALL_DIR}/bin ; chmod 755 ${CCTOOLS_INSTALL_DIR}/bin/$$file; done
+	for file in ${CYGWINLIB} ; do if [ -f /bin/$$file ] ; then ${CCTOOLS_INSTALL}  /bin/$$file ${CCTOOLS_INSTALL_DIR}/bin ; fi ; done
+	${CCTOOLS_INSTALL} work_queue_example.c ${CCTOOLS_INSTALL_DIR}/doc

=== ftp_lite/src/Makefile ===
include ../../Makefile.config
include ../../Makefile.rules

all: ftp_lite_test ftp_lite_copy libftp_lite.a

ftp_lite_test: ftp_lite_test.o libftp_lite.a
	${CCTOOLS_LD} $^ -o $@ -ldttools ${CCTOOLS_INTERNAL_LDFLAGS}

ftp_lite_copy: ftp_lite_copy.o libftp_lite.a
	${CCTOOLS_LD} $^ -o $@ -ldttools ${CCTOOLS_INTERNAL_LDFLAGS}

libftp_lite.a: ftp_lite.o error.o radix.o login.o stream.o network.o
	${CCTOOLS_AR} rv $@ $^
	ranlib $@

test:

clean:
	rm -f ftp_lite_test ftp_lite_copy libftp_lite.a core *~ *.o *.so so_locations

install:
	${CCTOOLS_INSTALL} -d ${CCTOOLS_INSTALL_DIR}/bin
	${CCTOOLS_INSTALL} -d ${CCTOOLS_INSTALL_DIR}/lib
	${CCTOOLS_INSTALL} -d ${CCTOOLS_INSTALL_DIR}/include
	${CCTOOLS_INSTALL} libftp_lite.a ${CCTOOLS_INSTALL_DIR}/lib
	${CCTOOLS_INSTALL} ftp_lite.h ${CCTOOLS_INSTALL_DIR}/include/cctools

=== ftsh/src/Makefile ===

include ../../Makefile.config
include ../../Makefile.rules

LOCAL_LDFLAGS=-ldttools ${CCTOOLS_INTERNAL_LDFLAGS}

PROGRAMS=ftsh
LIBRARIES=libftsh.a
SOURCES=ftsh.c ftsh_error.c ast.c ast_print.c ast_execute.c expr.c parser.tab.c scanner.c variable.c buffer.c timed_exec.c multi_fork.c cancel.c builtin.o

OBJECTS = ${SOURCES:%.c=%.o}
HEADERS = ${SOURCES:%.c=%.h}

all: ${PROGRAMS} ${LIBRARIES}

ftsh: ftsh.o libftsh.a
	${CCTOOLS_LD} $^ -o $@ ${LOCAL_LDFLAGS}

libftsh.a: ${OBJECTS}
	ar rv $@ $^
	ranlib $@

parser.tab.c parser.tab.h: parser.y
	bison -d parser.y

scanner.c: scanner.l parser.tab.h
	flex -t scanner.l > scanner.c

test:

install: all
	${CCTOOLS_INSTALL} -d ${CCTOOLS_INSTALL_DIR}/bin
	${CCTOOLS_INSTALL} ftsh ${CCTOOLS_INSTALL_DIR}/bin

clean:
	rm -f ${PROGRAMS} ${OBJECTS} ${LIBRARIES} parser.tab.c parser.tab.h scanner.c *~

=== makeflow/src/Makefile ===
CCTOOLS_HOME = ../../

include ${CCTOOLS_HOME}/Makefile.config
include ${CCTOOLS_HOME}/Makefile.rules

TARGETS = makeflow

LOCAL_LDFLAGS= -ldttools ${CCTOOLS_INTERNAL_LDFLAGS}

all: ${TARGETS}

makeflow: makeflow.o ${CCTOOLS_HOME}/dttools/src/libdttools.a
	${CCTOOLS_LD} makeflow.o ${LOCAL_LDFLAGS} -o $@

clean:
	rm -f core *~ *.o *.a ${TARGETS} 

test: all

install: all
	${CCTOOLS_INSTALL} -d ${CCTOOLS_INSTALL_DIR}/
	${CCTOOLS_INSTALL} -d ${CCTOOLS_INSTALL_DIR}/bin
	${CCTOOLS_INSTALL} makeflow ${CCTOOLS_INSTALL_DIR}/bin
	${CCTOOLS_INSTALL} -m 755 condor_submit_makeflow ${CCTOOLS_INSTALL_DIR}/bin
	${CCTOOLS_INSTALL} makeflow_log_parser ${CCTOOLS_INSTALL_DIR}/bin
	${CCTOOLS_INSTALL} makeflow_monitor ${CCTOOLS_INSTALL_DIR}/bin
	sed 's|/usr/bin/env python|${CCTOOLS_PYTHON}|' starch > starch.bin
	${CCTOOLS_INSTALL} -m 755 starch.bin ${CCTOOLS_INSTALL_DIR}/bin
	rm -f starch.bin

=== parrot/src/Makefile ===
include ../../Makefile.config
include ../../Makefile.rules

TARGETS = parrot_run libparrot_client.a libparrot_helper.so parrot_lsalloc parrot_mkalloc parrot_getacl parrot_setacl parrot_whoami parrot_locate parrot_md5 parrot_cp parrot_timeout
PARROT_OBJECTS =  pfs_main.o pfs_poll.o tracer.o pfs_dispatch.o pfs_dispatch64.o pfs_process.o pfs_channel.o pfs_sys.o pfs_table.o pfs_resolve.o pfs_service.o pfs_file.o pfs_file_cache.o pfs_dir.o pfs_dircache.o pfs_pointer.o pfs_location.o ibox_acl.o pfs_service_local.o pfs_service_http.o pfs_service_grow.o pfs_service_chirp.o pfs_service_multi.o pfs_service_nest.o pfs_service_ftp.o pfs_service_gfal.o pfs_service_lfc.o pfs_service_rfio.o pfs_service_dcap.o pfs_service_irods.o irods_reli.o pfs_service_hdfs.o pfs_service_bxgrid.o pfs_service_s3.o pfs_service_xrootd.o pfs_service_cvmfs.o

LOCAL_LDFLAGS=-lchirp -ls3client -ldttools -lftp_lite -ldl ${CCTOOLS_INTERNAL_LDFLAGS}

all: ${TARGETS}

parrot_run: ${PARROT_OBJECTS}
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

libparrot_helper.so: parrot_helper.c
	gcc -shared -fPIC $< -o $@

parrot_lsalloc: parrot_lsalloc.o parrot_client.o
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

parrot_mkalloc: parrot_mkalloc.o parrot_client.o
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

parrot_getacl: parrot_getacl.o parrot_client.o
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

parrot_setacl: parrot_setacl.o parrot_client.o
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

parrot_whoami: parrot_whoami.o parrot_client.o
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

parrot_locate: parrot_locate.o parrot_client.o
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

parrot_timeout: parrot_timeout.o parrot_client.o
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

parrot_md5: parrot_md5.o parrot_client.o
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

parrot_cp: parrot_cp.o parrot_client.o
	${CCTOOLS_LD} -o $@ $^ ${LOCAL_LDFLAGS}

libparrot_client.a: parrot_client.o
	ar rv $@ $^

pfs_main.o pfs_dispatch.o pfs_dispatch64.o pfs_process.o tracer.o: tracer.table.h tracer.table.c tracer.table64.h tracer.table64.c

tracer.table64.c: tracer.table64.in tracer.table.process
	perl tracer.table.process table 64 <$< >$@

tracer.table64.h: tracer.table64.in tracer.table.process
	perl tracer.table.process header 64 <$< >$@

tracer.table.c: tracer.table.in tracer.table.process
	perl tracer.table.process table 32 <$< >$@

tracer.table.h: tracer.table.in tracer.table.process
	perl tracer.table.process header 32 <$< >$@

test:

clean:
	rm -f core *~ *.o *.a ${TARGETS} tracer.table.c tracer.table.h tracer.table64.c tracer.table64.h

install: all parrot_client.h
	${CCTOOLS_INSTALL} -d ${CCTOOLS_INSTALL_DIR}
	${CCTOOLS_INSTALL} -d ${CCTOOLS_INSTALL_DIR}/bin
	${CCTOOLS_INSTALL} -d ${CCTOOLS_INSTALL_DIR}/lib
	${CCTOOLS_INSTALL} -d ${CCTOOLS_INSTALL_DIR}/include
	${CCTOOLS_INSTALL} -d ${CCTOOLS_INSTALL_DIR}/include/cctools
	${CCTOOLS_INSTALL} parrot_run ${CCTOOLS_INSTALL_DIR}/bin
	${CCTOOLS_INSTALL} libparrot_client.a ${CCTOOLS_INSTALL_DIR}/lib
	${CCTOOLS_INSTALL} parrot_client.h ${CCTOOLS_INSTALL_DIR}/include/cctools
	${CCTOOLS_INSTALL} libparrot_helper.so ${CCTOOLS_INSTALL_DIR}/lib
	${CCTOOLS_INSTALL} -m 755 parrot_identity_box ${CCTOOLS_INSTALL_DIR}/bin
	${CCTOOLS_INSTALL} -m 755 make_growfs ${CCTOOLS_INSTALL_DIR}/bin
	${CCTOOLS_INSTALL} parrot_mkalloc ${CCTOOLS_INSTALL_DIR}/bin
	${CCTOOLS_INSTALL} parrot_lsalloc ${CCTOOLS_INSTALL_DIR}/bin
	${CCTOOLS_INSTALL} parrot_setacl ${CCTOOLS_INSTALL_DIR}/bin
	${CCTOOLS_INSTALL} parrot_getacl ${CCTOOLS_INSTALL_DIR}/bin
	${CCTOOLS_INSTALL} parrot_whoami ${CCTOOLS_INSTALL_DIR}/bin
	${CCTOOLS_INSTALL} parrot_md5 ${CCTOOLS_INSTALL_DIR}/bin
	${CCTOOLS_INSTALL} parrot_cp ${CCTOOLS_INSTALL_DIR}/bin
	${CCTOOLS_INSTALL} parrot_locate ${CCTOOLS_INSTALL_DIR}/bin
	${CCTOOLS_INSTALL} parrot_timeout ${CCTOOLS_INSTALL_DIR}/bin
	${CCTOOLS_INSTALL} -m 755 parrot_run_hdfs ${CCTOOLS_INSTALL_DIR}/bin

=== sand/src/Makefile ===
--- 
+++ 
@@ -25,6 +25,6 @@
 	rm -f core *~ *.o *.os *.so $(PROGRAMS) libsandtools.a
 
 install: all
-	install -d ${CCTOOLS_INSTALL_DIR}
-	install -d ${CCTOOLS_INSTALL_DIR}/bin
-	for p in ${PROGRAMS} ${SCRIPTS}; do install $$p ${CCTOOLS_INSTALL_DIR}/bin; done
+	${CCTOOLS_INSTALL} -d ${CCTOOLS_INSTALL_DIR}
+	${CCTOOLS_INSTALL} -d ${CCTOOLS_INSTALL_DIR}/bin
+	for p in ${PROGRAMS} ${SCRIPTS}; do ${CCTOOLS_INSTALL} $$p ${CCTOOLS_INSTALL_DIR}/bin; done

=== wavefront/src/Makefile ===
CCTOOLS_HOME = ../../

include ${CCTOOLS_HOME}/Makefile.config
include ${CCTOOLS_HOME}/Makefile.rules

TARGETS =  wavefront wavefront_master

LOCAL_LDFLAGS=-ldttools ${CCTOOLS_INTERNAL_LDFLAGS}

all: ${TARGETS}


wavefront: wavefront.o 
	${CCTOOLS_LD} $^ ${LOCAL_LDFLAGS} -o $@

wavefront_master: wavefront_master.o 
	${CCTOOLS_LD} $^ ${LOCAL_LDFLAGS} -o $@

test:

clean:
	rm -f core *~ *.o *.a ${TARGETS} 

install: all
	${CCTOOLS_INSTALL} -d ${CCTOOLS_INSTALL_DIR}/
	${CCTOOLS_INSTALL} -d ${CCTOOLS_INSTALL_DIR}/bin
	${CCTOOLS_INSTALL} wavefront ${CCTOOLS_INSTALL_DIR}/bin
	${CCTOOLS_INSTALL} wavefront_master ${CCTOOLS_INSTALL_DIR}/bin

=== work_queue/src/perl/Makefile ===
--- 
+++ 
@@ -9,7 +9,7 @@
 
 work_queue_wrap.c work_queue.pm: ../work_queue.i
 	@echo "SWIG work_queue.i (perl5)"
-	@${CCTOOLS_SWIG} -perl5 -I${CCTOOLS_HOME}/dttools/src -o work_queue_wrap.c ../work_queue.i
+	@${CCTOOLS_SWIG} -perl5 -exportall -I${CCTOOLS_HOME}/dttools/src -o work_queue_wrap.c ../work_queue.i
 
 work_queue_wrap.o: work_queue_wrap.c
 	${CCTOOLS_CC} -fPIC -Wno-unused-value -Wno-unused-variable -c $< -o $@ ${ccflags}
@@ -25,6 +25,9 @@
 PERL_INSTALL_DIR=$(CCTOOLS_INSTALL_DIR)/lib/perl5/site_perl/$(CCTOOLS_PERL_VERSION)
 
 install: all
-	install -d $(PERL_INSTALL_DIR)
-	install work_queue.$(CCTOOLS_DYNAMIC_SUFFIX) $(PERL_INSTALL_DIR)/work_queue.$(CCTOOLS_DYNAMIC_SUFFIX)
-	install work_queue.pm $(PERL_INSTALL_DIR)/work_queue.pm
+	${CCTOOLS_INSTALL} -d $(PERL_INSTALL_DIR)
+	${CCTOOLS_INSTALL} -d ${CCTOOLS_INSTALL_DIR}/doc
+	${CCTOOLS_INSTALL} work_queue.$(CCTOOLS_DYNAMIC_SUFFIX) $(PERL_INSTALL_DIR)
+	${CCTOOLS_INSTALL} work_queue.pm $(PERL_INSTALL_DIR)
+	${CCTOOLS_INSTALL} work_queue_example.pl ${CCTOOLS_INSTALL_DIR}/doc
+

=== debian/changelog ===
cctools (3.5.1-2) unstable; urgency=low

  * Apply upstream patch to address parrot_run stalling on Debian wheezy and
    later (Closes: #678417).

 -- Michael Hanke <mih@debian.org>  Sat, 30 Jun 2012 11:35:24 +0200

cctools (3.5.1-1) unstable; urgency=low

  * New upstream bugfix release, adding support for version 3.2 Linux kernels.
  * Temporarily disabling the test suite upon upstream's request, as it
    generates to many false positives.

 -- Michael Hanke <mih@debian.org>  Fri, 29 Jun 2012 08:16:01 +0200

=== debian/control ===
--- 
+++ 
@@ -8,12 +8,10 @@
   libglobus-gss-assist-dev, net-tools, doxygen,
   libreadline6-dev | libreadline-dev, libncurses5-dev | libncurses-dev, swig,
   m4, mpi-default-dev
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Homepage: http://nd.edu/~ccl/software/
 Vcs-Browser: http://git.debian.org/?p=pkg-exppsy/cctools.git
 Vcs-Git: git://git.debian.org/git/pkg-exppsy/cctools.git
-XS-DM-Upload-Allowed: yes
-
 
 Package: coop-computing-tools
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -13,6 +13,10 @@
 		--with-mysql-path /usr --with-krb5-path /usr --with-readline-path /usr \
 		--with-mpi-path /usr --with-fuse-path /usr --with-zlib-path /usr \
 		--with-python-path /usr
+
+override_dh_auto_test:
+	# disable the tests for now on upstream's request. they will be reenabled
+	# once the test suite can properly deal with the buildd environment
 
 override_dh_auto_install:
 	dh_auto_install -- CCTOOLS_INSTALL_DIR=$(CURDIR)/debian/tmp
